unit GuitarChords1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Buttons, ExtCtrls,
	 StdCtrls, math;

type


   TChord = array[0..5] of Integer;

   TSemiTone = (sC,sCis,sD,sDis,sE,SF,sFis,sG,sGis,sA,sAis,sH);

   TChordSet = set of TSemiTone;

	 { TForm1 }

   TForm1 = class(TForm)
			Button1: TButton;
			Button2: TButton;
			Button3: TButton;
			CheckBox1: TCheckBox;
			GroupBox1: TGroupBox;
			GroupBox2: TGroupBox;
			GroupBox3: TGroupBox;
			Image1: TImage;
			Image2: TImage;
			ListBox1: TListBox;
			RadioGroup1: TRadioGroup;
			RadioGroup2: TRadioGroup;
			RadioGroup3: TRadioGroup;
			RadioGroup4: TRadioGroup;
			RadioGroup5: TRadioGroup;
			procedure Button1Click(Sender: TObject);
      procedure Button2Click(Sender: TObject);
			procedure Button3Click(Sender: TObject);
      procedure DrawFretBoard (Img : TImage; yOff : Integer; showZero: Boolean );
      Procedure DrawChord (aChord : TChord; BarreAt: Integer; YOff : integer);
			procedure FormDestroy(Sender: TObject);
			procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
				 Shift: TShiftState; X, Y: Integer);
			procedure RadioGroup5SelectionChanged(Sender: TObject);
      procedure ShowCord (Img: TImage; aChord: TChord; BarreAt: Integer; yOff: Integer);
      procedure BuildSet;
      procedure BuildFretBoard(BarreAt : Integer);
      procedure SolveChord (ClickCord: Tchordset);
			procedure FormCreate(Sender: TObject);
      procedure ShapesVisible (idx: Integer);
      procedure RadioGroup4SelectionChanged(Sender: TObject);
      procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
				 Y: Integer);

   private
   ChordSet : TChordSet;
   ClickCord : TChordSet;
   FretBoard : TChord;
   ClickFret : TChord;
   Shapes : array[0..5] of TShape;
   public

   end;

var
   Form1: TForm1;

implementation

{$R *.lfm}

const FretbordDist = 150;
      Bundlen = 48;
      SaitenDY =16;
      offsetX = BundLen;
      offsetY= 40;
      PressZero ='◎';
      Press = '◆';
      //PressZero='😎';
      //Press = '😊';
      IndianRed = $5C5CCD; // #CD5C5C
      GoldenRod = $20A5DA;  // #DAA520


// von hoch nach tief
const Guitar : TChord = (Ord(sE),ord (sH),Ord(SG),Ord(SD), ord(SA), Ord(sE));


var wood : TBitmap;

function WoodPixel (x,y,z : Integer) : TColor;
var radius, angle : single;
    xx,yy,zz : single;
    cycle : Integer;
    darkCol, lightCol : TColor;

    begin
    //function RGBToColor(R, G, B: Byte): TColor;
    lightCol := RGBToColor(200,150,0);
    darkCol:= RGBToColor(150,75,0);
    xx := x*20;
    yy := y;
    zz := z*100;
    radius := sqrt(sqr(xx)+sqr(yy));
    angle := arctan2(xx,zz);
    radius := radius + (48 *sin(20*angle + yy/150 ));
    cycle :=  round(radius) mod 60;
    if cycle < 40 then result := lightCol else result := DarkCol;
    end;


function WoodenBoard (Width, Height : Integer) : TBitmap;
var wood : TBitmap;
    x,y,z: Integer;
    col : TColor;

    begin
    wood := TBitmap.Create;
    wood.SetSize (Width, Height);
    z := 30;

    for x := 0 to wood.width - 1 do
       for y := 0 to wood.height - 1 do
        begin
        // we make horizontal wood structure. For vertical: exchange x and y in WoodPixel parameter
        col := woodPixel (y-height div 3,x,z);
        wood.Canvas.Pixels[x,y] := col;
        end;
    //wood.VerticalFlip;
    result := wood;
    end;




// Abstang Halbtöne, nur positive
function ToneDistance (T1,T2 : TSemiTone): integer;
var i1,i2 : Integer;
begin
i1 := Ord(T1);
i2 := Ord (T2);
result := abs(i1-i2);

end;



procedure TForm1.DrawFretBoard (Img : TImage; yOff : Integer; showZero: Boolean);
var i,x,dx,x1,y1: Integer;
    s: string;
		RSource, RDest: TRect;
    Col: TColor;
begin
With Img.Canvas do
   begin
   RDest := Rect (OffsetX,OffsetY,OffsetX+Wood.Width,OffsetY+Wood.height);

   case RadioGroup5.ItemIndex of
   0,1 : begin
         if RadioGroup5.ItemIndex = 0 then col := IndianRed else
           col := GoldenRod;
         Brush.Color:= col;
         fillRect(RDest);
         end;
   2: begin
      //Holz
		     RSource:= Rect (0,0,Wood.width,Wood.height);
		     copyRect(RDest,wood.canvas,RSource);
      end;
	 end;

   // Saiten
   Pen.Color := clRed;
   Pen.Width := 3;
   for i := 0 to 5 do
       line (offsetX, Yoff+offsety+i*SaitenDy,Image1.width,yOff+offsety+i*SaitenDy);
   if ShowZero then
       begin
       Pen.Color := clGray;
       for i := 0 to 5 do
        line (offsetX, Yoff+offsety+i*SaitenDy, offsetX - BundLen,Yoff+offsety+i*SaitenDy);
			 end;

   // Sattel
   x := OffsetX;
   Pen.Color := clBlack;
   Pen.width := 3;
   line (x,OffsetY+Yoff,x,OffsetY+Yoff + 5* SaitenDy);

   // Bünde
   Pen.width := 1;
   Pen.Color := clBlue;
   i := 0;
   while x < Image1.Width do
       begin
       line (x,OffsetY+Yoff,x,OffsetY+Yoff + 5* SaitenDy);
       s := IntToStr(i);
       dx := TextWidth(s) div 2;
       Brush.Style:= bsClear;
       TextOut (x-dx,OffsetY+Yoff + 5* SaitenDy+3,s);
       Brush.Style:= bsSolid;
       // Bundmarker
       if (odd(i) and NOT (i in [1,11,13])) or (i=12) then
         begin
         x1 := x - bundlen div 2;
         Pen.Color := clSilver;
         Brush.Color := clSilver;
         if i = 12 then
           begin
           y1 := Yoff+offsetY+round (1.5*SaitenDY);
           EllipseC(x1,y1,6,6);
           y1 := Yoff+offsetY+round (3.5*SaitenDY);
           EllipseC(x1,y1,6,6);
					 end else
           begin
	          y1 := Yoff+offsetY+round (2.5* SaitenDY);
	          EllipseC(x1,y1,6,6);
         end;
         Pen.Color := clBlue;
         Brush.Color := clNone;
				 end;
       inc(i);
       inc (x,BundLen);
	 end;  // while
 end;   // with
end; // proc


procedure  TForm1.ShowCord (Img: TImage; aChord: TChord; BarreAt: Integer; yOff: Integer);
var
	 i, y, x: Integer;
	 s: string;
begin
With Img.Canvas do
   begin
	 Brush.Style := bsClear;
   // Finger Symbole
	 for i :=0 to 5 do
     begin
     if aChord [i] = 0 then s := PressZero else s := Press;
     if achord[i] = 0 then x := Offsetx+2 else x := offsetX+ aChord[i]*Bundlen - 15;
     y := yOff+offsetY + i * SaitenDY- TextHeight(s) div 2;
     if (achord[i] = 0) or (achord[i] <> BarreAt) then TextOut (x,y,s);
		 end; // i
   Brush.Style := bsSolid;
	 end; // with

end;

Procedure TForm1.DrawChord (aChord : TChord; BarreAt: Integer; YOff : integer);

var i,x,y,dx,x1,y1 : Integer;
    s : string;
begin
DrawFretBoard (Image1, yOff, false);

With Image1.Canvas do
   begin
    // Barre Symbol
   if BarreAt > 0 then
      begin
      x := offsetX+ BarreAt*Bundlen - 10;
      Pen.Color := $87B8DE;
      Pen.width := 10;
      Line (x, OffsetY+Yoff,x,OffsetY+Yoff+5*SaitenDy);
      Pen.width := 1;
			end;
   Brush.Style := bsClear;
   // Finger Symbole
	 for i :=0 to 5 do
     begin
     if aChord [i] = 0 then s := PressZero else s := Press;
     if achord[i] = 0 then x := Offsetx+2 else x := offsetX+ aChord[i]*Bundlen - 15;
     y := yOff+offsetY + i * SaitenDY- TextHeight(s) div 2;
     if (achord[i] = 0) or (achord[i] <> BarreAt) then TextOut (x,y,s);
		 end; // i
   Brush.Style := bsSolid;
	 end; // with
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   if assigned (Wood) then wood.free;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
	 Shift: TShiftState; X, Y: Integer);
var saite, bund : integer;
begin
   bund := x div Bundlen;
   Saite := (y - offsetY + SaitenDY div 2) div SaitenDY;
   //showMessage ('Bund '+IntToStr(Bund)+' Saite '+IntToStr(Saite));
   if (Saite < 0) or (Saite > 5) then exit;
   if ClickFret[Saite] <> bund then ClickFret[Saite] := bund;
   Image2.canvas.Brush.Color := clWhite;
   Image2.canvas.FillRect(0,0,Image2.Width, Image2.Height);
   DrawFretBoard (Image2, 0, true);
   ShowCord(Image2,ClickFret,0,0);

end;

procedure TForm1.RadioGroup5SelectionChanged(Sender: TObject);
begin
   DrawFretBoard (Image2,0,true);
end;


 function FindBund (Saite: Integer; tone: TSemiTone): Integer;
 var found: Boolean = false;
     k : Integer;
 begin
  k := Guitar[Saite];
  result := 0;
  while not found do
    begin
    found := TSemiTone((k+result) mod 12) = tone;
    if not found then inc(result);
		end;
 end;



procedure TForm1.Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
	 Y: Integer);
   var sx,sy,bund,saite,dx,dy,i : Integer;
   tone : TSemiTone;
   s : string;
begin
   if RadioGroup4.ItemIndex > 0 then
      begin
      bund := x div Bundlen;
      Saite := (y - offsetY + SaitenDY div 2) div SaitenDY;
      if (Saite < 0) or (Saite > 5) then exit;
        sx := Bund* Bundlen + BundLen div 2 - Shapes[0].width div 2 +Image2.left;
        sy := offsetY + Saite*SaitenDY -  Shapes[0].height div 2+Image2.Top;
        tone := TSemiTone((guitar[Saite] + Bund) mod 12);
        WriteStr(s,tone);
        delete (s,1,1);
        dx := (Shapes[0].width - Shapes[0].Canvas.TextWidth(s) )  div 2;
        dy := (Shapes[0].height - Shapes[0].Canvas.Font.height) div 2 +1;

        if RadioGroup4.ItemIndex = 1 then  // 1 Saite
        begin
        Shapes[0].Canvas.TextOut(dx,dy,s);
        application.ProcessMessages;
        Shapes[0].Top := sy;
        Shapes[0].left := sx;
        Shapes[0].BringToFront;

        application.ProcessMessages;
				end else
        begin  // 6 Saiten
        Shapes[saite].Canvas.TextOut(dx,dy,s);
        application.ProcessMessages;
        Shapes[saite].Top := sy;
        Shapes[saite].left := sx;
        //Shapes[saite].BringToFront;
        for i := 0 to 5 do
           begin
           if i <> Saite then
              begin
              bund := FindBund (i,tone);
              Shapes[i].Canvas.TextOut(dx,dy,s);
              application.ProcessMessages;

              sx := Bund* Bundlen + BundLen div 2 - Shapes[0].width div 2 +Image2.left;
		          sy := offsetY + i*SaitenDY -  Shapes[0].height div 2+Image2.Top;
              shapes[i].Top := sy;
              shapes[i].Left := sx;
              application.ProcessMessages;
							end;
					 end;  // for
				end;

      end; // >0

end;


procedure TForm1.ShapesVisible (idx: Integer);
var i : integer;
begin
case idx of
0: for i := 0 to 5 do Shapes[i].Visible := false;
1: begin
   shapes[0].Visible:= true;
   for i := 1 to 5 do Shapes[i].Visible := false;
   end;
2:for i := 0 to 5 do Shapes[i].Visible := true;
end; // case
end;

procedure TForm1.RadioGroup4SelectionChanged(Sender: TObject);
begin
   ShapesVisible (RadioGroup4.ItemIndex);
end;

procedure TForm1.FormCreate(Sender: TObject);
var s : string;
    T : TSemiTone;
    i : Integer;
begin
for T := Low(TSemiTone) to high(TSemiTone) do
   begin
   writeStr(s,T);
   delete (s,1,1);
   RadioGroup1.Items.add(s);
	 end;
RadioGroup1.ItemIndex := 0;
wood := WoodenBoard (Image2.width-offsetX,5* SaitenDY );

for i := 0 to 5 do
  begin
  Shapes[i] := TShape.Create(self);
  With Shapes[i] do
     begin
     height := SaitenDY + 10;
     width := SaitenDY +10;
     shape := stCircle;
     brush.color := clAqua;
     Pen.Color := clBlue;
     canvas.Font.Height:= 14;
     canvas.Font.Style := [fsBold];
     Visible := true;
     Left := i * 30;
     Top := image2.Top;
     //bringToFront;
     Parent := self;
		 end; // with
	end;

Image1.Canvas.Brush.Color := clWhite;
Image1.Canvas.FillRect (0,0,Image1.Width,Image1.Height);
Image2.Canvas.Brush.Color := clWhite;
Image2.Canvas.FillRect (0,0,Image2.Width,Image2.Height);
DrawFretBoard (Image2, 0, true);
fillchar (ClickFret, sizeOf(ClickFret),0);
ShowCord(Image2,ClickFret,0,0);

end;

Procedure TForm1.BuildFretBoard (BarreAt: Integer);
var i,k, finger: integer;
    T : TSemiTone;
    found : Boolean;
begin
for i := 0 to 5 do
  begin
   k := Guitar[i]+BarreAt;
   finger := BarreAt;
   repeat
   T := TSemiTone(k mod 12);
   found := T in ChordSet;
   if found then FretBoard[i] := finger else
      begin
      inc (finger);
      inc(k);
			end;
	 until found;
	end;
end;

procedure TForm1.BuildSet;
var i,k, terz, sept : Integer;
    s : String = '';

begin
ChordSet := [];
i := RadioGroup1.ItemIndex;
Include(ChordSet, TSemiTone(i) );
if RadioGroup2.ItemIndex = 0 then Terz := 4 else Terz := 3;
k := (i+Terz) mod 12;
Include(ChordSet, TSemiTone(k) );
k := (i + 7) mod 12; // Quint
Include(ChordSet, TSemiTone(k) );
if RadioGroup3.ItemIndex > 0 then
  begin
  case RadioGroup3.ItemIndex of
  1: Sept := 11;   //  große
  2: sept := 10;   // kleine
  3 : sept := 9;   // verminderte
	end; // case
  k := (i+sept) mod 12;
  Include(ChordSet, TSemiTone(k) );
	end;// if
(* Test
for T := Low(TSemiTone) to High(TSemiTone) do
   begin
   if T in ChordSet then
        begin
        writeStr(tmp,t);
        s := s + tmp+LineEnding;
				end;
	 end;
showMessage (s);
*)
end;


procedure showSet (TestSet:TChordSet);
var T : TSemiTone;
    s : string = 'TestSet'+LineEnding;
    tmp: String;
begin
for T := low(TSemiTone) to high(TSemiTone) do
    begin
    if T  in Testset then
      begin
      writeStr(tmp,T);
      delete (tmp,1,1);
      s := s + tmp + LineEnding;
			end;
		end;
  //showMessage (s);
end;

function ChordComplete (C : TChord; SetOfChord :TChordSet; BarreAt: Integer; Missing: TSemiTone) : boolean;
var TestSet : Set of TSemiTone;
    i,k : Integer;
    T : TSemiTone;
    found : Boolean = false;
begin
TestSet := SetOfChord;
for i := 0 to 5 do
  begin
  k := Guitar[i];
  k := k + C[i];
  T := TSemiTone( k mod 12);
  //T := TSemiTone ((barreAt+C[i]+Guitar[i]) mod 12);
  Exclude(TestSet,T);
	end;
 result := Testset = [];
 showSet (TestSet);
 if not result then
    begin
    missing  := Low(TSemiTone);
    while not found do
       begin
       found := Missing in TestSet;
       if not found then inc(missing);
       end;
		end;
end;

function FingersOK (FretBoard : TChord; BarreAt: Integer): Boolean;
var i, count : integer;
begin
Count := 0;
 for i := 0 to 5 do if FretBoard[i] <> BarreAt then inc (Count);
 result := ((BarreAt <> 0) and (Count <4)  ) or
            ((BarreAt =0) and (Count <=4)   );

(* Barre verbieten:
---|--x-------
---|----------
---|----------
---|-----------
---|-x--------
---|--x------
*)

 if result and (BarreAt > 0) then
    begin
    if (FretBoard[0] = BarreAt+3) and (FretBoard[5]= BarreAt+3)
                               then result := false;
		end;
end;


// Nur für Entwicklung
procedure ShowFreBoard (FretBoard: TChord;BarreAt: Integer);
const LE = LineEnding;
var s : string = '';
    i : integer;
    begin
    s := 'BarreAt '+IntToStr(BarreAt) +LE;
    for i := 0 to 5 do s := s + IntTostr(FretBoard[i]) + LE;
    showMessage (s);
		end;

procedure TForm1.Button2Click(Sender: TObject);
var BarreAt,i,x : Integer;
    ok : Boolean;
    s : string;
    missing : TSemiTone;
begin
   Image1.Canvas.Brush.Color := clWhite;
   Image1.Canvas.FillRect (0,0,Image1.Width, Image1.Height);
   //  Anzeige Akkord
   s := RadioGroup1.Items[RadioGroup1.ItemIndex]+'-' +
        RadioGroup2.Items[RadioGroup2.ItemIndex];
   if RadioGroup3.ItemIndex>0 then s := s +' ' +
        RadioGroup3.Items[RadioGroup3.ItemIndex];
   x := (Image1.width - Image1.Canvas.TextWidth(s) ) div 2;
   Image1.Canvas.TextOut(x,3,s);

   BuildSet;
   if CheckBox1.checked then BarreAt := 1 else BarreAt := 0;
   for i := 0 to 2 do
   begin
   repeat
	    BuildFretBoard(BarreAt);
	    ok := FingersOK(FretBoard,BarreAt);
	    //ShowFreBoard (FretBoard,BarreAt);
	    if not OK then Inc (BarreAt);
   until ok;
   DrawChord(FretBoard,BarreAt,i*FretbordDist);
   (*
   if ChordComplete(FretBoard, ChordSet,BarreAt,missing) then
      showMessage(IntToStr(i)+' OK') else ShowMessage(IntToStr(i)+' NOT ok'); *)
   inc (BarreAt);
	 end; // for i
end;


procedure CreateSetFromFret (Fret: TChord; var ToneSet: TChordSet);
var i,k : integer;
    t : TSemiTone;
begin
ToneSet := [];
for i := 0 to 5 do
  begin
  k := (Guitar[i]+Fret[i]) mod 12;
  include (ToneSet,TSemiTone(k));
	end;
end;

function ToneToStr(T: TSemiTone) : string;
begin
writeStr(result,T);
delete (result,1,1);
end;



(*   C-Dur
     D    2     sus2
     F    5     sus4
     G
     Gis  8    / 6-

     A    9    / 6
     Ais 10    / 7-
     H   11    / 7
     C   12    / oktave
     Cis 13    / 9-   /8+
     D   14    / 9  kleine None
     Dis 15    / 9  große None
     E   16    / 10
     F   17    / 11 reine Undezime
     Fis 18    / 11+  verminderte Quint
     G  19   / 12, Quint)
     Gis  20     / kleine Tredezime, kleine sexte
     A    21    / 13   große Tredezime = große sexte
*)


procedure SplitString (s: string; var s1: string; var s2: string);
var p : integer;
begin
s2 := '';
trim(s);
p := pos ('&',s);
if p = 0 then s1 := s else
   begin
   s1 := copy (s,1,p+1);
   delete (s,1,p+1);
   s2 := s;
   trim(s2);
	 end;
end;

function Interval2String (Base, tone : TSemiTone) : string;
var delta : integer;
begin
result := '???';
delta := Ord(Tone) - ord(base);
if delta < 0 then inc(delta,12);
case delta of
  0: result := 'Prime';
  1: result := 'kleine None & kleine Sekunde';
  2: result := 'große None & große Sekunde';
  3: result := 'kleine Terz';
  4: result := 'große Terz';
  5: result := 'reine Quarte & Undezime';
  6: result := 'Tritonus';
  7: result := 'Quinte';
  8: result := 'kleine Tredezime & kleine Sexte';
  9: result := 'große Tredezime & große Sexte';
  10:result := 'kleine Septime';
  11:result := 'große Septime';
end; // case
end;

procedure TForm1.SolveChord (ClickCord: Tchordset);
var terz4, terz3, terz, quint : TSemiTone;
    major,minor,QuintFound,BaseCordFound: Boolean;
    base : TSemiTone;
    workSet : TChordSet;
    s : string;
    delta : integer;

procedure NoChord;
var t : TSemiTone;
begin
ListBox1.Items.add('Kein Akkord');
for t := low(TsemiTone) to high(TSemiTone) do
   if t in ClickCord then ListBox1.Items.add(ToneToStr(T));
end;

procedure showChordToList (base: TSemiTone; isMajor: Boolean);
var s,s1,s2: string;
    tn: TSemiTone;
begin
s := ToneToStr(base)+#32;
if isMajor then s := s +'Dur / ' else s := s+'Moll / ';
if isMajor then s := s+ ToneToStr(Terz4) else s := s + ToneToStr(Terz3);
s :=  s + ' / '+ToneTostr(quint);
ListBox1.Items.add (s);
workSet:=  ClickCord;
exclude (workSet, base);
if isMajor then exclude (workset,terz4) else exclude(workset,terz3);
exclude (workset,Quint);
for tn := low(TSemiTone) to high(TSemiTone) do
   begin
   if Tn in WorkSet then
      begin
      s := Interval2String(base,Tn);
      SplitString(s,s1,s2);
      s1 := ToneToStr(Tn)+#32+s1;
      ListBox1.Items.add (s1);
      if s2 <> '' then ListBox1.Items.add ('  '+s2);
  		end;

	 end;  // for
ListBox1.Items.add('=======');
end;

procedure NextChord(StartWith: TSemiTone);
var t,t1: TSemiTone;
begin

    BaseCordFound:= false;
    //showMessage ('NextChord Start '+ToneToStr(StartWith));
    for T :=  StartWith to high(TSemiTone) do
        begin
        base := T;
        WorkSet := ClickCord;

        quint := TSemiTone( (Ord(t)+7) mod 12);
        QuintFound:= (T in ClickCord) and (quint in ClickCord);
        If QuintFound then
           begin
           base := T;
           terz4 := TSemiTone((Ord(T) +4) mod 12);
           terz3 := TSemiTone((Ord(T) +3) mod 12);
           major := terz4 in ClickCord; // Dur
           minor := terz3 in ClickCord; // Moll
           if major or minor then  // Grundakkord gefunden
              begin
              Exclude(WorkSet,base);
              ExcLude (WorkSet,Quint);
              if major then exclude (WorkSet,terz4);
              if minor then exclude (Workset, terz3);
              BaseCordFound := true;
              break;
							end;
					 end;

				end; // for T
        If BaseCordFound then
        begin
        if Major then showChordToList (base,true);
        if Minor then showChordToList (base,false);
        end else
        begin
         (*
         if QuintFound then
         begin
         ListBox1.Items.add('Quinte ohne Terz gefunden');
         ListBox1.Items.add(ToneToStr(base));
         ListBox1.Items.add(ToneToStr(quint));
         end else begin ListBox1.Items.add('Seltsam');
                    ListBox1.Items.add('Weder Dur noch Moll');
                    for T1 := low(TSemiTone) to high(TSemiTone) do
                      begin
                      if T1 in ClickCord then ListBox1.Items.add(ToneToStr(T1));
											end;

                    exit; end;
         *)
        end;
     end; // NextChord;

begin
ListBox1.Clear;
NextChord (Low(TsemiTone));
  repeat
  if base < High(TSemiTone) then
    begin
    inc(base);
    NextChord(base);
		end else break;
	until true;
  if ListBox1.Count = 0 then NoChord;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
CreateSetFromFret (ClickFret, ClickCord);
SolveChord (ClickCord);
end;


procedure TForm1.Button3Click(Sender: TObject);
var st : TStringList;
begin
   close;
end;


end.

